library f_jpeg;

{
 this is source code for JPEG plug-in, used by Futuris Imager

 NOTES:
   - turn on run-time packages if you use Delphi 5
   - form dfm is in text format, suitable only for Delphi 5
     there is some utility to convert it from text to binary
     (see Delphi help for this)
   - this plug-in uses standard jpeg unit
   - FIPISinfo is very basic
   - FIPISconfig not implemented (just dummy message box)
}

uses
  SysUtils,
  Windows,
  Classes,
  Graphics,
  Jpeg,
  info in 'info.pas' {frmInfo};

{$R *.RES}
{$R FIPIS.RES}

function FIPISopen(path,ext: PChar; app: THandle):hBitmap; stdcall;
var
   bmp: TBitmap;
   jpg: TJpegImage;
begin
bmp:=TBitmap.Create();
jpg:=TJpegImage.Create();
try
   jpg.LoadFromFile(String(path));
   bmp.Height:=jpg.Height;
   bmp.Width:=jpg.Width;
   bmp.Canvas.Draw(0,0,jpg);
   Result:=bmp.ReleaseHandle();
   except
         on EInvalidGraphic do Result:=0;
         end;
bmp.Free();
jpg.Free();
end;

function FIPISconfig(app: THandle):integer; stdcall;
begin
MessageBox(app,'Not yet implemented','',MB_OK+MB_ICONINFORMATION);
Result:=1;
end;

function FIPISsave(path,ext: PChar; app: THandle; img: hBitmap):integer; stdcall;
var
   bmp: TBitmap;
   jpg: TJpegImage;
begin
bmp:=TBitmap.Create();
jpg:=TJpegImage.Create();
Result:=1;
try
   bmp.Handle:=img;
   jpg.Assign(bmp);
   jpg.SaveToFile(String(path));
   except
         Result:=0;
   end;
bmp.Free();
jpg.Free();
end;

function FIPISabout(var name, version, descr, author, misc: PChar):integer; stdcall;
begin
name:='Futuris JPEG Library';
version:='1.0';
descr:='Support for JPEGs';
author:='Alexander S. Tereschenko';
misc:='Uses code from Independent JPEG Group - http://www.ijg.org';
Result:=1;
end;

exports
       FIPISopen, FIPISsave, FIPISabout, FIPISconfig, FIPISinfo;

begin
end.
 